%def_without static
%def_with milter

%def_with ownconfdir
%if_with ownconfdir
%define clamconfdir /etc/clamav
%else
%define clamconfdir /etc
%endif

Name: clamav
Version: 0.86.2
Release: alt1
Summary: An anti-virus utility for Unix
License: GPL
URL: http://www.clamav.net/
Group: File tools
Packager: Victor Forsyuk <force@altlinux.ru>
%ifdef snap
Source0: http://download.sourceforge.net/clamav/clamav-devel-%snap.tar.gz
%else
Source0: http://download.sourceforge.net/clamav/clamav-%version.tar.gz
%endif
Source1: clamav.init
Source2: clamav.sysconfig

Source4: freshclam.cron
Source5: freshclam.logrotate
Source6: clamav.logrotate

Source10: clamav-milter.init
Source11: clamav-milter.sysconfig
Source12: clamav-milter.msg
Source13: clamav-milter.whitelist

Source20: virusstat-perIP
Source21: virusstat-perIP-PrevHour
Source22: virusstat-total
Source23: virusstat.cron.example

Patch1: clamav-config.patch
Patch2: freshclam-config.patch

Patch10: clamav-milter-20040922-template.patch
Patch11: clamav-milter-20041206-ip-to-log.patch
Patch12: clamav-milter-0.86.1-log.patch

# Package with clamd should require libclamav, not vice versa.
# Corresponding libclamav version need to be updated before, or clamd restart may fail!
Requires: lib%{name} = %version-%release

# postinstall uses subst utility
Requires(post): sed >= 1:3.02-alt1

# bc and sed used by configure script
BuildRequires: sed

# Automatically added by buildreq on Mon Jul 11 2005
# ...and edited manually to separate conditional build deps (and remove exim-common :-)
BuildRequires: bc bzlib-devel libcurl-devel libgmp-devel libidn-devel libssl-devel zlib-devel

# for snapshots
%ifdef snap
BuildRequires: automake_1.8
%endif

%{?_with_static:BuildRequires: glibc-devel-static}
%{?_with_milter:BuildRequires: sendmail-common sendmail-devel sendmail-libs}

%description
Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose
of this software is the integration with mail servers (attachment
scanning). The package provides a flexible and scalable
multi-threaded daemon, a commandline scanner, and a tool for
automatic updating via Internet. The programs are based on a
shared library distributed with the Clam AntiVirus package, which
you can use in your own software.

%package -n lib%{name}
Summary: Shared libraries for clamav
Group: Development/C

%description -n lib%{name}
Shared libraries for clamav.

%package -n lib%{name}-devel
Summary: Development header files and libraries for clamav
Group: Development/C
Requires: %name = %version

%description -n lib%{name}-devel
This package contains the development header files and libraries
necessary to develop clamav client applications.

%package -n lib%{name}-devel-static
Summary: clamav static libraries
Group: Development/C
Requires: lib%{name}-devel = %version

%description -n lib%{name}-devel-static
clamav static libraries.

%package milter
Summary: clamav-milter for sendmail
Group: File tools
Requires: clamav = %version, sendmail

%description milter
This package contains the filter for Sendmail necessary to
integrate clamav with Sendmail MTA.

%package manual
Summary: ClamAV User Manual
Group: Books/Howtos

%description manual
This package contains user manual for clamav in HTML format.

%prep
%setup -q %{?snap: -n clamav-devel-%snap}
%patch1 -p1
%patch2 -p1

%patch10 -p0
%patch11 -p0
#%patch12 -p0

%build
%ifdef snap
aclocal
%endif

# --disable-clamav: Disable test for clamav user/group
%configure \
	--sysconfdir=%clamconfdir \
	--disable-clamav \
	--with-user=mail \
	--with-group=mail \
	--without-tcpwrappers \
	--with-libcurl \
	--with-dbdir=/var/lib/%name %{?_with_milter: --enable-milter --with-sendmail=/usr/sbin/sendmail}

# configure trying to get sendmail version (used in milter code) from installed sendmail!
# I'd like to simplify build on boxes with alternative MTA installed so I prefer to just
# add needed strings:
cat <<EOF >>clamav-config.h
#define SENDMAIL_VERSION_A 8
#define SENDMAIL_VERSION_B 13
#define SENDMAIL_VERSION_C 4
EOF
# NB: yes, hardcoded. If you want to build clamav-milter for older sendmail
# change numbers accordingly!

%make_build

install -m644 %_sourcedir/virusstat* .

tar zxf contrib/clamdmon/clamdmon-*
cd clamdmon*
make CFLAGS="%optflags"

%install
make install DESTDIR=$RPM_BUILD_ROOT

%{!?_with_milter:rm -f $RPM_BUILD_ROOT%_man1dir/clamav-milter*}

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d/init.d,sysconfig,cron.d,logrotate.d}
install -d $RPM_BUILD_ROOT%{_var}/log/clamav

install -m755 %_sourcedir/clamav.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamd
install -m755 %_sourcedir/clamav-milter.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamav-milter

install %_sourcedir/clamav.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamd

%if_with milter
#install -m644 %_sourcedir/clamav-milter.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamav-milter
%__sed -e 's|@@CLAMAVCONFDIR@@|%clamconfdir|' < %_sourcedir/clamav-milter.sysconfig > $RPM_BUILD_ROOT/etc/sysconfig/clamav-milter
install -m644 %_sourcedir/clamav-milter.whitelist $RPM_BUILD_ROOT%clamconfdir/
install -m644 %_sourcedir/clamav-milter.msg $RPM_BUILD_ROOT%clamconfdir/
%endif

touch $RPM_BUILD_ROOT%{_var}/log/clamav/clamd.log
touch $RPM_BUILD_ROOT%{_var}/log/clamav/freshclam.log

# install the logrotate stuff
install -m644 %_sourcedir/freshclam.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/freshclam
install -m644 %_sourcedir/clamav.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/clamav

# install config files _explicitly_
# they will not be installed by 'make install' if exists in build system :-\
install -m644 etc/clamd.conf $RPM_BUILD_ROOT%clamconfdir/
#install -m644 etc/freshclam.conf $RPM_BUILD_ROOT%clamconfdir/
%__sed -e 's|@@CLAMAVCONFDIR@@|%clamconfdir|' < etc/freshclam.conf > $RPM_BUILD_ROOT%clamconfdir/freshclam.conf

# pid file dir
install -d $RPM_BUILD_ROOT/var/run/clamav

# install clamdmon
pushd clamdmon*
install -m755 clamdmon %buildroot%_bindir/
subst 's@/usr/local/sbin@/usr/bin@' clamdmon.sh
popd

# install html docs
%__mkdir_p %buildroot/%_defaultdocdir/clamav-manual
%__rm -rf docs/html/CVS
install -m644 docs/html/* %buildroot/%_defaultdocdir/clamav-manual

# remove non-packaged files
%__rm -f %buildroot%_libdir/*.la
%__rm -f %buildroot/var/lib/clamav/*.cvd
%if_without static
%__rm -f %buildroot%_libdir/*.a
%endif

cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/cron.d/freshclam
30 * * * *       root    %_bindir/freshclam --quiet --daemon-notify
EOF

%post
# virus db format changed with 0.65, so delete old databases
%__rm -f /var/lib/clamav/viruses.db*

%post_service clamd

# randomize time of database updating (in order to distribute load on servers evenly)
RNDM=$[$RANDOM/555]
/usr/bin/subst s/^[0-9]*/$RNDM/ %_sysconfdir/cron.d/freshclam

%preun
%preun_service clamd

%post -n lib%{name} -p %post_ldconfig
%postun -n lib%{name} -p %postun_ldconfig

%post milter
%post_service clamav-milter

%preun milter
%preun_service clamav-milter

%files
%doc AUTHORS BUGS ChangeLog README docs/clamdoc.*
%doc docs/signatures.* clamdmon*/clamdmon.sh
%doc virusstat*

%_bindir/clamdscan
%_bindir/clamscan
%_bindir/freshclam
%_bindir/sigtool
%_bindir/clamdmon
%_sbindir/clamd
%config %_initdir/clamd
%{?_with_ownconfdir: %dir %clamconfdir}
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/*.conf
%config(noreplace) %_sysconfdir/logrotate.d/clamav
%attr(640,root,root) %config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamd
%_man1dir/clamdscan*
%_man1dir/clamscan*
%_man1dir/freshclam*
%_man1dir/sigtool*
%_man5dir/*
%_man8dir/clamd*
%attr(3775,root,mail) %dir /var/lib/clamav
%attr(3775,root,mail) %dir /var/run/clamav
%attr(3771,root,mail) %dir /var/log/clamav
%attr(640,mail,root) %ghost /var/log/clamav/clamd.log
%attr(644,mail,mail) %ghost /var/log/clamav/freshclam.log
%config(noreplace) %_sysconfdir/cron.d/freshclam
%config(noreplace) %_sysconfdir/logrotate.d/freshclam

%files -n lib%{name}
%_libdir/lib*.so.*

%files -n lib%{name}-devel
%_bindir/clamav-config
%_libdir/lib*.so
%_libdir/pkgconfig/*
%_includedir/*.h

%files manual
%_defaultdocdir/clamav-manual

%if_with static
%files -n lib%{name}-devel-static
%_libdir/lib*.a
%endif

%if_with milter
%files milter
%_sbindir/clamav-milter
%config %_initdir/clamav-milter
%config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamav-milter
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/*.msg
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/clamav-milter.whitelist
%_man8dir/clamav-milter.*
%endif

%changelog
* Tue Jul 26 2005 Victor Forsyuk <force@altlinux.ru> 0.86.2-alt1
- 0.86.2

* Mon Jul 11 2005 Victor Forsyuk <force@altlinux.ru> 0.86.1-alt1
- 0.86.1.
- Enable scanning RAR archives in default config.
- Hack to define sendmail version used in clamav-milter code when
  building on boxes without sendmail installed.

* Tue May 17 2005 Victor Forsyuk <force@altlinux.ru> 0.85.1-alt1
- 0.85.1.

* Wed May 04 2005 Victor Forsyuk <force@altlinux.ru> 0.84-alt1
- 0.84 release.
- Allow replacement of rc.d service script during upgrades
  (i.e., remove "noreplace" in spec).

* Fri Apr 08 2005 Victor Forsyuk <force@altlinux.ru> 0.84-alt0.rc1
- Add clamdmon to package.
- Move HTML docs to separate package.

* Thu Feb 17 2005 Victor Forsyuk <force@altlinux.ru> 0.83-alt2
- clamav-milter tweaks from Sergey Afonin.

* Mon Feb 14 2005 Victor Forsyuk <force@altlinux.ru> 0.83-alt1
- 0.83.

* Mon Feb 07 2005 Victor Forsyuk <force@altlinux.ru> 0.82-alt1
- 0.82.

* Thu Jan 27 2005 Victor Forsyuk <force@altlinux.ru> 0.81-alt2
- 0.81.
- Fix from Sergey Afonin: add `bc' to BuildRequires.
- Patch to fix freshclam error with buggy proxy servers (that answers
  in HTTP/1.0 when we requested HTTP/1.1).

* Fri Jan 21 2005 Victor Forsyuk <force@altlinux.ru> 0.81-alt1.rc1
- 0.81rc1.
- Address BTS #5377.

* Fri Oct 29 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt4
- Check for database updates hourly.
- Fix path to config file in NotifyClamd.

* Mon Oct 18 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt3
- 0.80.
- Patches from Sergey Afonin.

* Tue Oct 12 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt2.rc4
- Mark clamav-milter startup script as noreplaced config.
- Small fix in database updating time randomizer.
- Modify clamav-milter sysconfig file.
- Move config files to /etc/clamav.
- Tweak initscripts priorities to start clamd before clamav-milter
  and both of them before MTA.

* Wed Sep 29 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt1.rc3
- 0.80rc3.

* Mon Aug 30 2004 Victor Forsyuk <force@altlinux.ru> 0.75.1-alt2
- Build --without-tcpwrappers to fix bug #5064.

* Mon Aug 02 2004 Victor Forsyuk <force@altlinux.ru> 0.75.1-alt1
- 0.75.1

* Fri Jun 25 2004 Victor Forsyuk <force@altlinux.ru> 0.73-alt1
- 0.73.
- Add pkgconfig file and clamav-config to -devel package.

* Wed May 19 2004 Victor Forsyuk <force@altlinux.ru> 0.71-alt1
- New version.

* Wed Apr 21 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt2
- New version.
- Freshclam launching time randomized at package installation.
  Thanks to Sergey Afonin <asy <at> kraft-s.ru> for idea.

* Wed Apr 14 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt1.20040414
- Build (post-0.70rc) snapshot from 2004/04/14.

* Mon Mar 01 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt2.20040301
- Build snapshot from 2004/03/01.
- Fix logrotate for clamd logs.
- Add --daemon-notify to options freshclam run with.
- Add build with milter and create clamav-milter subpackage.

* Sun Feb 15 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt1
- New version.
- Checks for new database every two hours (suggested by clamav authors).
- Rotate logs weekly (was monthly).

* Thu Dec 18 2003 Victor Forsyuk <force@altlinux.ru> 0.65-alt0.1
- New version.
- Removed *.la files.
- Do not build devel-static subpackage by default.

* Fri Jun 27 2003 Victor Forsyuk <force@altlinux.ru> 0.60-alt1
- Initial build for Sisyphus.
